﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows;
using System.Collections.ObjectModel;

namespace DragDrop
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            dgTable.DataItems.Add(new Item { Action = "Action 1", Player1 = "Player 1", Player2 = "Player 2", Team1 = "1", Team2 = "2", Period = 1, In = 12, Out = 35, Timecode = "00:12:34.12", Time = 47, Export = true,  ActionType = "TestType", Frame = 12035, FrameOut = 12095, InValue = 10.4, OutValue = 5.67, ProjectPath = @"c:\", VideoFilePath = "", VideoSyncPath = "", Font = null });
            dgTable.DataItems.Add(new Item { Action = "Action 2", Player1 = "Player 1", Player2 = "Player 2", Team1 = "1", Team2 = "2", Period = 1, In = 12, Out = 35, Timecode = "00:12:34.12", Time = 47, Export = true, ActionType = "TestType", Frame = 12035, FrameOut = 12095, InValue = 10.4, OutValue = 5.67, ProjectPath = @"c:\", VideoFilePath = "", VideoSyncPath = "", Font = null });
            dgTable.DataItems.Add(new Item { Action = "Action 3", Player1 = "Player 1", Player2 = "Player 2", Team1 = "1", Team2 = "2", Period = 1, In = 12, Out = 35, Timecode = "00:12:34.12", Time = 47, Export = true, ActionType = "TestType", Frame = 12035, FrameOut = 12095, InValue = 10.4, OutValue = 5.67, ProjectPath = @"c:\", VideoFilePath = "", VideoSyncPath = "", Font = null });
        }

        public class Item
        {
            public String Action { get; set; }
            public String Player1 { get; set; }
            public String Player2 { get; set; }
            public String Team1 { get; set; }
            public String Team2 { get; set; }
            public int Period { get; set; }
            public int In { get; set; }
            public int Out { get; set; }
            public string Timecode { get; set; }
            public int Time { get; set; }
            public Boolean Export { get; set; }
            public String ActionType { get; set; }
            public int Frame { get; set; }
            public int FrameOut { get; set; }
            public double InValue { get; set; }
            public double OutValue { get; set; }
            public String ProjectPath { get; set; }
            public String VideoFilePath { get; set; }
            public String VideoSyncPath { get; set; }
            public Object Font { get; set; }
        }


        #region DragDrop

        DataRecordPresenter dp;
        DataRecordPresenter dragOver;
        int currentIndex;
        int overIndex;
        Border b;

        private void DragSource_Drop(object sender, Infragistics.DragDrop.DropEventArgs e)
        {
            ResetBorder();

            if (overIndex >= 0)
            {
                Item row = new Item();
                row = dp.DataRecord.DataItem as Item;
                if (row != null)
                {
                    dgTable.DataItems.Remove(row);
                    dgTable.DataItems.Insert(overIndex, row);
                    dgTable.ActiveDataItem = row;
                }
            }

            dgTable.FieldLayoutSettings.HighlightAlternateRecords = true;
        }

        private void DragSource_DragStart(object sender, Infragistics.DragDrop.DragDropStartEventArgs e)
        {
            dp = Utilities.GetAncestorFromType(e.DragSource as DependencyObject, typeof(DataRecordPresenter), false) as DataRecordPresenter;

            if (dp.DataRecord.IsDataRecord)
            {
                dgTable.FieldLayoutSettings.HighlightAlternateRecords = false;
                currentIndex = dp.Record.Index;
            }
            else
            {
                e.Cancel = true;
            }
        }

        private void CardPanel_MouseDown(object sender, MouseButtonEventArgs e)
        {
            e.Handled = true;
        }

        private void DragSource_DragOver(object sender, Infragistics.DragDrop.DragDropMoveEventArgs e)
        {
            dragOver = Utilities.GetAncestorFromType(e.DropTarget as DependencyObject, typeof(DataRecordPresenter), false) as DataRecordPresenter;
            overIndex = dragOver.Record.VisibleIndex;
            SetBorder();
        }

        private void DragSource_DragEnter(object sender, Infragistics.DragDrop.DragDropCancelEventArgs e)
        {
            b = Utilities.GetDescendantFromName(e.DropTarget, "DropHighlightBorder") as Border;
            SetBorder();
        }

        private void SetBorder()
        {
            if (currentIndex == overIndex)
            {
                ResetBorder();
            }
            else if (b != null)
            {
                Color c = (Color)ColorConverter.ConvertFromString("#72FF0000");
                b.BorderBrush = new SolidColorBrush(c);
                b.BorderThickness = (currentIndex < overIndex) ? new Thickness(0, 0, 0, 5) : new Thickness(0, 5, 0, 0);
            }
        }

        private void ResetBorder()
        {
            b.BorderBrush = Brushes.Transparent;
        }

        private void DragSource_DragLeave(object sender, Infragistics.DragDrop.DragDropEventArgs e)
        {
            ResetBorder();
        }

        #endregion
    }
}
